/**

    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.monitoring.core;

import org.spagic.metadb.model.TransitionInstance;
import org.spagic.metadb.model.TransitionState;
import org.spagic.monitoring.message.MessageIFace;


public interface MonitorIService {
	
	public static class TransitionManagementState {
		public boolean transitionTerminated = false; 	// If the transition is terminated, this variable
		  												// is setted and used to check if the process is terminated
		public boolean processFault = false; 			// If the message exchange has the status fault, set the entire
		  												// process state to faulted
														// transitionTerminated and processFault are exclusives
		public TransitionState transitionState = null;	// Transition status to save in log_journal table
	}
	
	public class TransitionInstanceCreationResult {
		public TransitionInstance transitionInstance = null;
		public boolean processInstanceCreated = false;
		public TransitionManagementState transitionManagementState = null;
	}
	
	/**
	 * Main method: perform the monitoring of all exchanges.
	 * @param exchange
	 */
	public void traceMessage(MessageIFace message);

}
