/**

    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.monitoring.smx.listeners.debug;

import javax.jbi.servicedesc.ServiceEndpoint;
import javax.xml.namespace.QName;

import org.apache.servicemix.jbi.container.JBIContainer;
import org.apache.servicemix.jbi.deployment.Connection;
import org.apache.servicemix.jbi.deployment.Consumes;
import org.apache.servicemix.jbi.deployment.Provides;
import org.apache.servicemix.jbi.deployment.ServiceAssembly;
import org.apache.servicemix.jbi.deployment.ServiceUnit;
import org.apache.servicemix.jbi.deployment.Services;
import org.apache.servicemix.jbi.event.EndpointEvent;
import org.apache.servicemix.jbi.event.EndpointListener;
import org.apache.servicemix.jbi.event.ServiceAssemblyEvent;
import org.apache.servicemix.jbi.framework.ComponentMBeanImpl;
import org.apache.servicemix.jbi.framework.ComponentNameSpace;
import org.apache.servicemix.jbi.framework.Registry;
import org.apache.servicemix.jbi.framework.ServiceAssemblyLifeCycle;
import org.apache.servicemix.jbi.framework.ServiceUnitLifeCycle;

public class ServiceAssemblyListener implements
		org.apache.servicemix.jbi.event.ServiceAssemblyListener,
//		org.apache.servicemix.jbi.container.ContainerAware,
		EndpointListener {
	
	private JBIContainer container = null;

	
	public ServiceAssemblyListener() {
		super();
	}

	public void assemblyDeployed(ServiceAssemblyEvent event) {
		ServiceAssemblyLifeCycle assembly = event.getAssembly();
		System.out.println(" ***************** ASSEMBLY ["+assembly.getName()+"] DEPLOYED  ***************** ");
//		logServiceAssembly(assembly);
	}

	public void assemblyShutDown(ServiceAssemblyEvent event) {
		ServiceAssemblyLifeCycle assembly = event.getAssembly();
		System.out.println(" ***************** ASSEMBLY ["+assembly.getName()+"] SHUTDOWN  ***************** ");
		//logServiceAssembly(assembly);
	}

	public void assemblyStarted(ServiceAssemblyEvent event) {
		ServiceAssemblyLifeCycle assembly = event.getAssembly();
		System.out.println(" ***************** ASSEMBLY ["+assembly.getName()+"] STARTED  ***************** ");
		//logSA(assembly);
	}

	public void assemblyStopped(ServiceAssemblyEvent event) {
		ServiceAssemblyLifeCycle assembly = event.getAssembly();
		System.out.println(" ***************** ASSEMBLY ["+assembly.getName()+"] STOPPED  ***************** ");
		//logServiceAssembly(assembly);
	}

	public void assemblyUndeployed(ServiceAssemblyEvent event) {
		ServiceAssemblyLifeCycle assembly = event.getAssembly();
		System.out.println(" ***************** ASSEMBLY ["+assembly.getName()+"] UNDEPLOYED  ***************** ");
		//logServiceAssembly(assembly);
	}

	public void setContainer(JBIContainer container) {
		this.container = container;
	}
	public void logSA(ServiceAssemblyLifeCycle saLifeCycle){
//		String saName = saLifeCycle.getName();
		Registry registry = container.getRegistry();
//		String[] jbiComponents = registry.getComponentsForDeployedServiceAssembly(saName);
		
		ServiceEndpoint[] allExternalSeps = registry.getExternalEndpoints(null);
		for (int i=0; i < allExternalSeps.length; i++){
			System.out.println("Endpoint "+ allExternalSeps[i]);
		}
		ServiceEndpoint[] allInternalSeps = registry.getEndpointsForInterface(null);
		for (int i=0; i < allInternalSeps.length; i++){
			System.out.println("Endpoint "+ allInternalSeps[i]);
		}
		/*
		Collection components = registry.getComponents();
     
		for (Iterator iter = components.iterator(); iter.hasNext();) {
			
			ComponentMBeanImpl component = (ComponentMBeanImpl)iter.next();
			ServiceEndpoint[] seps = component.getContext().getEndpoints(null);
			for (int i=0; i < seps.length; i++){
				System.out.println("Endpoint "+ seps[i]);
			}
			System.out.println(component.getComponentNameSpace() + "-->  Endpoints ["+registry.getEndpointsForComponent(component.getComponentNameSpace()).length+"] ["+seps.length+"]");            
        }
		
		registry.getBindingComponents();
		
		for (int i=0; i < jbiComponents.length; i++){
			 ComponentNameSpace cns = new ComponentNameSpace(container.getName(), jbiComponents[i]);
			 System.out.println(cns + "-->  Endpoints ["+registry.getEndpointsForComponent(cns).length+"]");            
		}
		*/
		
	}
	public void logServiceAssembly(ServiceAssemblyLifeCycle assemblyLifeCycle) {
        ServiceAssembly serviceAssembly = assemblyLifeCycle.getServiceAssembly();
        System.out.println(" -- CONNECTIONS -- " );
		boolean logConnections = true;
        if (serviceAssembly.getConnections() == null ||
            serviceAssembly.getConnections().getConnections() == null) {
			logConnections = false;
		}
        if (logConnections){
			Connection[] connections = serviceAssembly.getConnections().getConnections();
			for (int i = 0; i < connections.length; i++) {
				if (connections[i].getConsumer().getInterfaceName() != null) {
					QName fromItf = connections[i].getConsumer().getInterfaceName();
					QName toSvc = connections[i].getProvider().getServiceName();
                	String toEp = connections[i].getProvider().getEndpointName();
                	System.out.println(" -- INTERFACE CONNECTION FROM INTERFACE ["+fromItf+"] TO SERVICENAME ["+toSvc+"] TO ENDPOINT NAME["+toEp+"]" );
            	} else {
            		QName fromSvc = connections[i].getConsumer().getServiceName();
                	String fromEp = connections[i].getConsumer().getEndpointName();
                	QName toSvc = connections[i].getProvider().getServiceName();
                	String toEp = connections[i].getProvider().getEndpointName();
                	System.out.println(" -- INTERFACE CONNECTION FROM SERVICENAME ["+fromSvc+"] FROM ENDPOINT NAME ["+fromEp+"] TO SERVICENAME ["+toSvc+"] TO ENDPOINT NAME["+toEp+"]" );
           	 	}
			}
		}
        System.out.println(" -- SERVICE UNITS -- " );
        ServiceUnitLifeCycle[] sus = assemblyLifeCycle.getDeployedSUs();
        ServiceUnit[] serviceUnits = assemblyLifeCycle.getServiceAssembly().getServiceUnits();
        for (int i=0; i< sus.length; i++){
        	logSUS(sus[i]);
        }  
    }

	public void logSUS(ServiceUnitLifeCycle su){
		System.out.println(" ----> Service Unit Lifecycle ["+su.getName()+"] ["+su.getComponentName()+"]");
		
		Services services = su.getServices();
		
		//logServices(services);
		
		String componentName = su.getComponentName();
		ComponentNameSpace cns = new ComponentNameSpace(container.getName(), componentName);
		
		ServiceEndpoint[] sendPoints = container.getRegistry().getEndpointsForComponent(cns);
		ComponentMBeanImpl componentMbean = container.getComponent(componentName);
		for (int i=0; i < sendPoints.length; i++){
			System.out.println(sendPoints[i].toString());
		}
	}
	
	public void logServices(Services services){
		if (services != null){
			if (services.isBindingComponent())
				System.out.println(" --------> (BC) Services ");
			else
				System.out.println(" --------> (SE) Services ");
			Provides[] provides = services.getProvides();
			if (provides != null){
				for (int i=0; i < provides.length; i++){
					System.out.println("---------------> Provider EndPoint["+provides[i].getEndpointName()+"] Interface ["+provides[i].getInterfaceName()+"] Service ["+provides[i].getServiceName()+"]");
				}
			}
			Consumes [] consumes = services.getConsumes();
			if (consumes != null){
				for (int i=0; i < consumes.length; i++){
					System.out.println("---------------> Consumer EndPoint["+consumes[i].getEndpointName()+"] Interface ["+consumes[i].getInterfaceName()+"] Service ["+consumes[i].getServiceName()+"]");
				}
			}
		}
	}

	public void externalEndpointRegistered(EndpointEvent event) {
		System.out.println(" REGISTERED ExternalEndpoint ["+ event.getEndpoint().getEndpointName()+"] Service["+event.getEndpoint().getServiceName()+"");
		
	}

	public void externalEndpointUnregistered(EndpointEvent event) {
		System.out.println(" UNREGISTERED ExternalEndpoint ["+ event.getEndpoint().getEndpointName()+"] Service["+event.getEndpoint().getServiceName()+"");
		
	}

	public void internalEndpointRegistered(EndpointEvent event) {
		System.out.println(" REGISTERED InternalEndpoint ["+ event.getEndpoint().getEndpointName()+"] Service["+event.getEndpoint().getServiceName()+"");
		
	}

	public void internalEndpointUnregistered(EndpointEvent event) {
		System.out.println(" UNREGISTERED InternalEndpoint ["+ event.getEndpoint().getEndpointName()+"] Service["+event.getEndpoint().getServiceName()+"");
		
	}

	public void linkedEndpointRegistered(EndpointEvent event) {
		System.out.println(" REGISTERED LinkedEndpoint ["+ event.getEndpoint().getEndpointName()+"] Service["+event.getEndpoint().getServiceName()+"");
		
	}

	public void linkedEndpointUnregistered(EndpointEvent event) {
		System.out.println(" REGISTERED LinkedEndpoint ["+ event.getEndpoint().getEndpointName()+"] Service["+event.getEndpoint().getServiceName()+"");
		
	}

	public void remoteEndpointRegistered(EndpointEvent event) {
		System.out.println(" REGISTERED RemoteEndPoint ["+ event.getEndpoint().getEndpointName()+"] Service["+event.getEndpoint().getServiceName()+"");
		
	}

	public void remoteEndpointUnregistered(EndpointEvent event) {
		System.out.println(" UNREGISTERED RemoteEndPoint ["+ event.getEndpoint().getEndpointName()+"] Service["+event.getEndpoint().getServiceName()+"");
		
	}

		
}
