/**

    Copyright 2007, 2008 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package org.spagic.monitoring.smx.listeners.debug;

import javax.jbi.messaging.MessageExchange;
import javax.jbi.messaging.NormalizedMessage;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.servicemix.JbiConstants;
import org.apache.servicemix.jbi.event.ExchangeEvent;
import org.apache.servicemix.jbi.event.ExchangeListener;
import org.apache.servicemix.jbi.messaging.MessageExchangeImpl;


public class SimpleExchangeListener implements ExchangeListener {
	private static final Log log = LogFactory.getLog(SimpleExchangeListener.class);
	public static final Object lock = new Object();
	
	public static final String MEP_INONLY = "org.apache.servicemix.jbi.messaging.InOnlyImpl";
	public static final String MEP_INOUT = "org.apache.servicemix.jbi.messaging.InOutImpl";
	public static final String MEP_ROBUSTINONLY = "org.apache.servicemix.jbi.messaging.RobustInOnlyImpl";
	public static final String MEP_INOPTIONALOUT = "org.apache.servicemix.jbi.messaging.InOptionalOutImpl";
	
	public void exchangeSent(ExchangeEvent event) {
        //System.out.println(" ============================ Exchange accepted  ================================== ");
		 MessageExchange exchange = event.getExchange();
	        if (exchange instanceof MessageExchangeImpl == false) {
	            throw new IllegalArgumentException("exchange should be a MessageExchangeImpl");
	        }
	        
	        synchronized (lock) {
        		log.info(" ============================ Exchange ["+exchange.getExchangeId()+"] ================================== ");
        		log.info("Sender: "+exchange.getProperty(JbiConstants.SENDER_ENDPOINT));
        		log.info("CorrelationId: "+exchange.getProperty(JbiConstants.CORRELATION_ID));
        		log.info("Service: " + exchange.getService());
        		log.info("Endpoint: " + exchange.getEndpoint());
        		log.info("Status: " + exchange.getStatus());
        		log.info(exchange);
	        }	
    		
    		/*
    		try{
    			if (in != null){
    				log.info(" *** IN Mesage *** ");
    				log.info(st.toString(in.getContent()));
    				log.info(" ********************** ");
    			}
    		
    			if (out != null){
    				log.info(" *** IN Mesage *** ");
    				log.info(st.toString(out.getContent()));
    				log.info(" ********************** ");
    			}
    		}catch(Exception e){
    			e.printStackTrace();
    		}*/
	        /*	
	        	synchronized (lock) {
	        		System.out.println(" ============================ Exchange  ================================== ");
	        		System.out.println("Id & status: " + exchange.getExchangeId() + " " + exchange.getStatus());
	        		System.out.println("MEP: " + exchange.getClass().getName());
	        		System.out.println("CorrelationID: "+exchange.getProperty(JbiConstants.CORRELATION_ID));
	        		System.out.println("Sender: "+exchange.getProperty(JbiConstants.SENDER_ENDPOINT));
	        		System.out.println("Service: " + exchange.getService());
		            System.out.println("Endpoint: " + exchange.getEndpoint());
	        		
	        		NormalizedMessage in = exchange.getMessage("in");
	        		NormalizedMessage out = exchange.getMessage("out");
	        		System.out.println(exchange);
	        		if (in != null){
	        			System.out.println(" *** Properties of IN Mesage *** ");
	        			Set<String> propNames = in.getPropertyNames();
		        		for (String n : propNames){
		        			 System.out.println("---> Property ["+n+"] ["+in.getProperty(n)+"]");
		        		}
	        		}
	        		
	        		if (out != null){
	        			System.out.println(" *** Properties of OUT Mesage *** ");
	        			Set<String> propNames = out.getPropertyNames();
		        		for (String n : propNames){
		        			 System.out.println("---> Property ["+n+"] ["+out.getProperty(n)+"]");
		        		}
	        		}
		            /*
		            System.out.println(" ============================ Exchange  ================================== ");
		            System.out.println("MEP: " + exchange.getClass().getName());
		            System.out.println("Id & status: " + exchange.getExchangeId() + " " + exchange.getStatus());
	            	System.out.println("Sender: "+exchange.getProperty(JbiConstants.SENDER_ENDPOINT));
		            System.out.println("Service: " + exchange.getService());
		            System.out.println("Endpoint: " + exchange.getEndpoint());
		            System.out.println("Role: " + exchange.getRole());
		            System.out.println("Interfacename: " + exchange.getInterfaceName());
		            System.out.println("Operation: " + exchange.getOperation());
		            
		            
		            System.out.println(" ----- Properties ");
		            Set exchangePropertyNames = exchange.getPropertyNames();
		            String propertyName = null;
		            
		            for (Iterator it = exchangePropertyNames.iterator(); it.hasNext(); ){
		            	propertyName = (String)it.next();
		            	System.out.println(" ----- Property ["+propertyName+"] --> ["+exchange.getProperty(propertyName)+"]");
		            }
		            System.out.println(exchange);
		            */
					

	
	        	
				
		
	}


	public SimpleExchangeListener() {
		super();
	}


	
	public String getMep(MessageExchange exchange) {
		String mepClassName = exchange.getClass().getName();
		return mepClassName;
	}
	
	public void traceMessage(NormalizedMessage message) {
		
	}


	public void exchangeAccepted(ExchangeEvent arg0) {
		
		//System.out.println(" ============================ Exchange sent  ================================== ");
	
	}

	

}
